;===============================================================================
; 1 LED-i vilgutaja
;=============================================================================== 
;*********************** Raudvrk **********************************************
;*** vljundid ***
#define LED				PORTA,0					; esimese LEDi juhtimine, aktiivne = HIGH
#define LED1			PORTA,1					; teise LEDi juhtimine, aktiivne = HIGH
; ********************** constantsid *******************************************
#define viiteaega			0x02				; mrab ra LED'i vilkumise kestuse
#define viiteaegb			0x04				; sama
#define viiteaegc			.198				; sama
#define viiteaegd			.200				; sama

	LIST    p=16F628  							; Nimetame prose
	#include "P16F628.INC"  					; siit failist loeb kompilaator protsessori info	
				errorlevel -302					; Compaileri vingumised ra
				errorlevel -305					; Compaileri vingumised ra
; prose konfiguratsioon
	__CONFIG _WDT_OFF&_XT_OSC&_PWRTE_ON&_CP_OFF&_MCLRE_ON&_BODEN_OFF&_LVP_OFF

; ************** Mlu jaotus **********	    	
			cblock 0x20							; kasutaja mlublokk pangas 0
				cnt0
				cnt1
				cnt2
				cnt3
			endc
; **** Prose lipukesed ****
#define CARRY           	STATUS,C 
#define ZERO            	STATUS,Z 
#define pank            	STATUS,RP0
; *****************************	    	

				org	0x0000
;===============================================================================
; ********************** philuup **********************************************
;===============================================================================
main:			movlw	0x07					; komparaatorid OFF
				movwf	CMCON					; komparaatorite juhtregistrisse
				clrf	PORTA					; nullime pordi
				bsf		pank					; siirdume mlupanka 1
				movlw	0x00					; tugipingeallikas OFF
				movwf	VRCON					; kirjutame tugipinge allika juhtregistrisse
				movlw   B'11000000'				; Kvarts otsad on sisendid, muud vljundid
    			movwf	TRISA					; kirjutame pordi juhtregistrisse
				bcf		pank					; tagasi mlupanka 0
				movlw	B'11000000'				; olgu alguses pordi kik vljundotsad madalad
    			movwf	PORTA					; kirjutame porti, LEDid peavad nd kustuma
main_1:			call	viide					; molutame umbes 1 sekundi, siis stame LEDi
				bsf		LED						; PORTA vljund 0 krgeks (LED sttib)
				bcf		LED1					; kustutame teise LED'i
				call	viide					; veel 1 sekund viidet
				bcf		LED						; kustutame LED-i
				bsf		LED1					; stame teise LED-i
				goto	main_1					; jtkame niiviisi kuni patarei thjaks saab...
; **** aja viitmise alamprogramm ****
; laeme mlupesad cnt0...cnt3 umbes 1 sekundi andva viite konstantidega
viide:			movlw	viiteaega				; arv 2 (kulub 1uS)
		 		movwf	cnt0					; mlupessa cnt0 (kulub 1uS)
viide1:			MOVLW	viiteaegb 				; arv 4 (kulub 1uS)
				MOVWF	cnt1					; mlupessa cnt1 (kulub 1uS)
viide2:			MOVLW	viiteaegc				; arv 198 (kulub 1uS)	
				MOVWF	cnt2					; mlupessa cnt2 (kulub 1uS)
viide3:			MOVLW	viiteaegd				; arv 200 (kulub 1uS)	
				MOVWF	cnt3					; mlupessa cnt3 (kulub 1uS)
viide4:			DECFSZ	cnt3					; lahuta mlupesa sisust 1 (kulub 1uS)	
				GOTO	viide4					; tee seda kuni cnt3 sisu on null, siis vta jrgmine ksk (kulub 2uS)
				DECFSZ	cnt2					; lahuta mlupesa sisust 1 (kulub 1uS)
				goto	viide3					; tee seda kuni cnt2 sisu on null, siis vta jrgmine ksk	(kulub 2uS)
				DECFSZ	cnt1					; lahuta mlupesa sisust 1 	(kulub 1uS)	
				goto	viide2					; tee seda kuni cnt1 sisu on null, siis vta jrgmine ksk (kulub 2uS)
				DECFSZ	cnt0					; lahuta mlupesa sisust 1 	(kulub 1uS)	
				goto	viide1					; tee seda kuni cnt0 sisu on null, siis vta jrgmine ksk (kulub 2uS)	
				return							; prdume tagasi phiprogrammi (kulub 2uS)
	end			
;******************************************************************************
