;===============================================================================
; 2 LED-i vilgutaja taimeriga
;=============================================================================== 
;*********************** Raudvrk **********************************************
;*** vljundid ***
#define LED				PORTA,0					; esimese LEDi juhtimine, aktiivne = HIGH
#define LED1			PORTA,1					; teise LEDi juhtimine, aktiivne = HIGH
; ********************** constantsid *******************************************
#define viiteaegH			0x0B				; mrab ra LED'i vilkumise kestuse
#define viiteaegL			0xDC				; sama

	LIST    p=16F628  							; Nimetame prose
	#include "P16F628.INC"  					; siit failist loeb kompilaator protsessori info	
				errorlevel -302					; Compaileri vingumised ra
				errorlevel -305					; Compaileri vingumised ra
; prose konfiguratsioon
	__CONFIG _WDT_OFF&_XT_OSC&_PWRTE_ON&_CP_OFF&_MCLRE_ON&_BODEN_OFF&_LVP_OFF

; ************** Mlu jaotus **********	    	
			cblock 0x20							; mlu enam ei kasuta, kokkuhoid 4 baiti !
			endc
; **** Prose lipukesed ****
#define CARRY           	STATUS,C 
#define ZERO            	STATUS,Z 
#define pank            	STATUS,RP0
; *****************************	    	

				org	0x0000
;===============================================================================
; ********************** philuup **********************************************
;===============================================================================
main:			movlw	0x07					; komparaatorid OFF
				movwf	CMCON					; komparaatorite juhtregistrisse
				clrf	PORTA					; nullime pordi
				bsf		pank					; siirdume mlupanka 1
				movlw	0x00					; tugipingeallikas OFF
				movwf	VRCON					; kirjutame tugipinge allika juhtregistrisse
				movlw   B'11000000'				; Kvarts otsad on sisendid, muud vljundid
    			movwf	TRISA					; kirjutame pordi juhtregistrisse
				bcf		pank					; tagasi mlupanka 0
				movlw	B'11000000'				; olgu alguses pordi kik vljundotsad madalad
    			movwf	PORTA					; kirjutame porti, LEDid peavad nd kustuma
; *** konfime  viitetaimeri T1 ***
				movlw	B'00110000'				; eeljagur 1:8, sisemine takt, taimer hetkel veel seisab
				movwf	T1CON					; laeme taimeri juhtregistrisse.
main_1:			call	viide					; molutame umbes 0,5 sekundit, siis stame LEDi
				bsf		LED						; PORTA vljund 0 krgeks (LED sttib)
				bcf		LED1					; kustutame teise LED'i
				call	viide					; veel 0,5 sekundit viidet
				bcf		LED						; kustutame LED-i
				bsf		LED1					; stame teise LED-i
				goto	main_1					; jtkame niiviisi kuni patarei thjaks saab...
; **** aja viitmise alamprogramm ****
viide:			movlw	viiteaegH				; laeme taimeri sobiva jagamisteguriga
				movwf	TMR1H
				movlw	viiteaegL
				movwf	TMR1L
				bcf		PIR1,TMR1IF				; igaks juhuks taimeri letitumise lipp nulli
				bsf		T1CON,TMR1ON			; paneme taimeri kima, ajaarvetus algab sellest hetkest
viide_1:		btfss	PIR1,TMR1IF				; ootame letitumist
				goto	viide_1
				bcf		T1CON,TMR1ON			; taimer seisma
				return							; prdume tagasi phiprogrammi
	end			
;******************************************************************************
