;===============================================================================
; Atwoodi masina kontroller I praxi jauks. 4.8.2005. 
; 18.8.: parandus, nd mdab enam-vhem. Aeg ei ole 1mS vaid 1,029mS - tpsustada!
; lisada moded ja nupud ning smistor?
;=============================================================================== 
;*********************** Raudvrk **********************************************
;*** hardwrk ***
;*** LCD jm. vljundid ***
#define LCD_En			PORTA,3					; LCD stobeerimine, aktiivne = HIGH (- front)
#define LCD_RS			PORTA,4					; LCD registri valik: DATA = HIGH, CMD = LOW
#define LCD_D7			PORTB,7					; LCD databus, 4 bitti
#define LCD_D6			PORTB,6					
#define LCD_D5			PORTB,5					
#define LCD_D4			PORTB,4					
#define BUZ				PORTA,2					; plmpa juhtimine, aktiivne HIGH

#define CARRY           	STATUS,C 
#define ZERO            	STATUS,Z 
#define pank            	STATUS,RP0
;******* LCD *******
#define	LCDMaxX				0x10				; 16 smbolit
#define	LCDMaxY				0x01				; 2 rida
#define CurHome				0x02				; LCD ksk: "kursor rea algusesse"
#define	rida2				0xC0				; LCD 2. rea aadress

	LIST    p=16F628  	; Nimetame prose

	#include "P16F628.INC"  	
				errorlevel -302					; Compaileri vingumised ra
				errorlevel -305
				errorlevel -306 

;	__CONFIG _WDT_ON&_XT_OSC&_PWRTE_ON&_CP_OFF&_MCLRE_OFF&_BODEN_ON&_LVP_OFF
	__CONFIG _WDT_OFF&_INTRC_OSC_NOCLKOUT&_PWRTE_ON&_CP_OFF&_MCLRE_OFF&_BODEN_ON&_LVP_OFF

; ************** Mlu jaotus **********	    	
count1			equ	0x68
temp			equ	0x6C
tmp				equ	0x6F
lcdtmp			equ	0x71
LCD_Count		equ	0x72
t_count			equ	0x73			
t1_count		equ	0x74			
large_count		equ	0x7C
 			;	endc
; ************* Lipud ****************	    	



; *****************************	    	

				org	0
				goto	main
;===============================================================================
; ********************** philuup **********************************************
;===============================================================================
main			call	init					; kodu korda...
				clrwdt
				call	Init_LCD				; LCD jonxu
				call	LCD_Graph				; laeme taepitaehed
				call	Beep
				call	LCD_tekst
				call	Long_Wait
				call	Long_Wait
				call	Long_Wait
				call	Long_Wait
				goto	main
;===============================================================================
; ********************** funktsioonid ******************************************
;===============================================================================
;===============================================================================
; *******************LCD funktsioonid ******************************************
;===============================================================================
; ******************************************************************************
; ******** saadab HEX (BCD)baidi registrist W LCD-skriinile ********************
; ******************************************************************************
HEX2LCD:   		movwf   tmp         
				swapf   tmp,W         
				call    Nibble2ASCII 
				addlw	0x30
				call    Send_DATA    			; LCD-le    
				movf    tmp,W         
HEX2LCD1:		call    Nibble2ASCII         
				addlw	0x30					
				call    Send_DATA    			; LCD-le    
				return  
; ***** Convert Nibble to ASCII Hex Digit *****  
Nibble2ASCII         
				andlw   h'0F'         
				addlw   h'F6'         
				btfsc   CARRY         
				addlw   h'07'         
				addlw   h'0A'         
				return  
;===============================================================================
; ************** lhtesta displeile ********************************************
;===============================================================================
Init_LCD:;		call	LCD_port_o				; LCD port vljundiks
			    call    Wait_2ms        		; las rahuneb veel veidi        
      			call    Wait_2ms        		; las rahuneb veel veidi      
      			call    Wait_2ms        		; las rahuneb veel veidi      
      			call    Wait_2ms        		; las rahuneb veel veidi      
				movlw   b'00110000'     		; Set 8 bit interface 
				call    Send_CMD8                  
				movlw   b'00110000'     		; Set 8 bit interface         
				call    Send_CMD8                  
				movlw   b'00110000'     		; Set 8 bit interface         
				call    Send_CMD8                  
				movlw   b'00100000'     		; Set 4 bit interface         
				call    Send_CMD                 
				movlw   b'00101000'     		; 4 bit  2 line  5x7         
				call    Send_CMD                  
				movlw   b'00001000'     		; Displei off         
				call    Send_CMD                  
;				movlw   b'10000000'     		; DDRAM adr=0
;				call    Send_CMD                  
				movlw   b'00000001'     		; Clear Display
				call    Send_CMD                  
				movlw   b'00000110'     		; Cursor increment  no Shi(f)t         
				call    Send_CMD                  
				movlw   b'00001100'     		; Disp On  Cursor Off  Blink On         
				call    Send_CMD                 
				movlw   b'00101000'     		; 4 bit  2 line  5x7         
				call    Send_CMD   
;				call	LCD_port_i				; LCD port sisendiks               
				return  
;===============================================================================
; ******** mine ekraanil soovitud kohale ***************************************
;===============================================================================
gotoXY:			IORLW	0x80					; DDRAM adr.
				call    Send_CMD                  
				RETURN
;===============================================================================
; ******** saada displeile omad smbolid **************************************
;===============================================================================
LCD_Graph:;		call	LCD_port_o				; LCD port vljundiks
		    	movlw   b'01000000'     		; CGRAM set to 0
				call    Send_CMD                  
          		clrf    LCD_Count 
LCD_Graph_L:         
				movf	PCLATH,W
				movwf	temp
				movlw   HIGH GraphDef
				movwf   PCLATH   
   				call	GraphDef				; loe bait
				movwf	lcdtmp
				movf	temp,W
				movwf	PCLATH	
				movf	lcdtmp,W	
				call    Send_DATA                  
				incf    LCD_Count,1         
				movf    LCD_Count,W         
				sublw   d'32'         
				btfss   ZERO         
				goto    LCD_Graph_L  
;				call	LCD_port_i				; LCD port sisendiks
				return         
;===============================================================================
; ******************** saada Data displeile ************************************
;===============================================================================
Send_DATA:   	movwf	lcdtmp 					; seivi daata (8-bitine!)
				andlw	0xF0					; koristame noorema nibble ra
				movwf	PORTB					; vanem nibble LCD-le
				bsf     LCD_RS   				; daata mood   
				nop
				nop
				nop 
				bsf     LCD_En  
				nop
				nop
				nop 
				nop
				nop
				nop 
				bcf     LCD_En  
				nop
				nop
				nop 
				bcf     LCD_RS   				 
				swapf	lcdtmp,W				; leia daata noorem nibble
				andlw	0xF0					; koristame noorema nibble ra
				movwf	PORTB					; vanem nibble LCD-le
				bsf     LCD_RS   				; daata mood   
				nop
				nop
				nop 
				bsf     LCD_En  
				nop
				nop
				nop 
				nop
				nop
				nop 
				bcf     LCD_En  
				nop
				nop
				nop 
				bcf     LCD_RS   				 
      			call    Wait_2ms        		; las rahuneb veel veidi      
				return  
;===============================================================================
; **************** saada 8-bitine ksk displeile *******************************
;===============================================================================
Send_CMD:		  
			  	movwf	lcdtmp 					; seivi ksk (8-bitine!)
				andlw	0xF0					; koristame noorema nibble ra
				movwf	PORTB					; vanem nibble LCD-le
				bcf     LCD_RS   				; cmd mood 
				nop
				nop
				nop 
				bsf     LCD_En  
				nop
				nop
				nop 
				nop
				nop
				nop 
				bcf     LCD_En  
				nop
				nop
				nop 
				swapf	lcdtmp,W				; leia daata noorem nibble
				andlw	0xF0					; koristame noorema nibble ra
				movwf	PORTB					; vanem nibble LCD-le
				bcf     LCD_RS   				; cmd mood   
				nop
				nop
				nop 
				bsf     LCD_En  
				nop
				nop
				nop 
				nop
				nop
				nop 
				bcf     LCD_En  
      			call    Wait_2ms        		; las rahuneb veel veidi      
				return  
;===============================================================================
; **************** saada 8-bitine ksk displeile *******************************
;===============================================================================
Send_CMD8:				; seivi ksk (8-bitine!)
				bcf     LCD_RS   				; cmd mood   
				movwf	PORTB					; vanem nibble LCD-le
				nop
				nop
				nop 
				bsf     LCD_En  
				nop
				nop
				nop 
				nop
				nop
				nop 
				bcf     LCD_En  
				nop
				nop
				nop 
				bcf     LCD_En  
      			call    Wait_2ms        		; las rahuneb veel veidi      
				return  
;===============================================================================
; ************ saada tekstistring ROMist displeile *****************************
;===============================================================================
LCD_tekst:;		call	LCD_port_o				; LCD port vljundiks               
				clrf	t1_count				; loendi
				movlw	CurHome		     		; kursor koju
				call    Send_CMD                  
LCD_tekst_1:	movf	PCLATH,W
				movwf	temp
				movlw   HIGH Mes_tabel
				movwf   PCLATH   
;				movf	t1_count,W
   				call	Mes_tabel				; loe bait
				movwf	lcdtmp
				movf	temp,W
				movwf	PCLATH	
				movf	lcdtmp,W	
				sublw	0xFF
				btfsc	ZERO
				return		
LCD_tekst_2:	movf	lcdtmp,W
				call    Send_DATA 				; saada LCD-le
				incf	t1_count				; nekst
;				movlw	0x10					; kik ?
;				subwf	t1_count,W
;				btfss	ZERO
				goto	LCD_tekst_1
		;		call	LCD_port_i				; LCD port sisendiks  
				return
;===============================================================================
; ********** loeb vastuvtu puhvrist 16 smbolit ja kirjtab LCD-le pos. X,Y ****
;===============================================================================
writelcdxy:;		call	LCD_port_o				; LCD port vljundiks
				movlw   b'10000000'     		; DDRAM adr=0
				call    Send_CMD  
				incf	FSR						; loe saadetavate baitide arv
				movf	INDF,W                
				sublw	LCDMaxX					; ega mitte rohkem kui 16 smbolit ?
				btfss	CARRY
				return				; teavitame valest ksust
				movf	INDF,W                
				movwf	LCD_Count
				incf	FSR,F					; pos. Y
				movf	INDF,W                
				sublw	LCDMaxY					; ega mitte rohkem kui 2. rida ?
				btfss	CARRY
				return							; teavitame valest ksust
				movf	INDF,W
				btfss	ZERO					; rida 1 ?
				movlw	rida2					; ei, rida 2
				movwf	lcdtmp
				incf	FSR,F					; pos. X
				movf	INDF,W
				addwf	lcdtmp,W
				call	gotoXY					; vta soovitud koht sisse
				incf	FSR,F					; viita esimesele daatabaidile
writelcdxy1:	movf	INDF,W					; loe smbol puhvrist
;				sublw	0x1F					; kontrollime kas ASCII char
;				btfsc	CARRY
;				goto	writelcdxy2				; vale asi, vta jrgmine
;				movf	INDF,W					; lemine piir
				sublw	0x7E
				btfss	CARRY
				goto	writelcdxy2				; vale asi, vta jrgmine
				movf	INDF,W					; char ok, taastame ja ...
				call	Send_DATA				; ...saada LCD-le
writelcdxy2:	incf	FSR,F
				decfsz	LCD_Count
				goto	writelcdxy1				; tskkel
;				call	LCD_port_i				; port sisendiks tagasi
;				bcf		INTCON,RBIF				; igax juhux nagu mungalgi....
				return
;===============================================================================
; ******************** piiks ***************************************************
;===============================================================================
Beep:  			movlw   d'100'           		; Tsklite arv         
				movwf   t1_count 
Beep_Loop:		bsf     BUZ         			; mla !
				call    Wait_1ms         
				bcf     BUZ         			; mla maha
				call    Wait_1ms         
				decfsz  t1_count,1         
				goto    Beep_Loop         
				return  
;===============================================================================
; ********************** viited ************************************************
;===============================================================================
; ***** 20 usec *****  
wait_20us		movlw	0x05
				movwf   t_count 
				goto	W60u_Loop
; ***** 60 usec *****  
Wait_60us         
				movlw   d'20'         
				movwf   t_count 
W60u_Loop         
				decfsz  t_count,F          
				goto W60u_Loop              
				return  
; ***** 196 usec *****  
Wait_Bit         
				movlw   d'65'         
				movwf   t_count 
W196u_Loop         
				decfsz  t_count,1   		; 1         
				goto W196u_Loop         		; 2         
				return  
; ***** 2 msec *****  
Wait_1ms         
				movlw   d'100'          		; 200 x 10us = 2000us = 2ms         
				movwf   t_count 
				goto	W1m_Loop
Wait_2ms         
				movlw   d'200'          		; 200 x 10us = 2000us = 2ms         
				movwf   t_count 
W1m_Loop         
				nop                     		; 1         
				nop                     		; 2         
				nop                     		; 3         
				nop                     		; 4         
				nop                     		; 5         
				nop                     		; 6         
				nop                     		; 7         
				decfsz  t_count,1   		; +1         
				goto W1m_Loop           		; +2 = 10 cycles         
				return    
; ***** x msec *****  
Long_Wait       movlw   d'150'                  ; No of Cycles         
				movwf   t1_count 
Long_Wait_Loop  call    Wait_2ms         
				decfsz  t1_count,1         
				goto    Long_Wait_Loop         
				return  
;===============================================================================
; ********************** initsialiseerimine ************************************
;===============================================================================
init:;			clrf	STATUS					;
				clrf	PORTA					; 
				clrf	PORTB					;
				clrf	TMR1L
				clrf	TMR1H
;				clrf	TMR2
;-------------------------------
				movlw	B'00000111'				; analoog-komparaatorid OFF
				movwf	CMCON					
				bsf		STATUS,RP0				; Pank 1
				movlw	B'00100011'				; tugipinge OFF
				movwf	VRCON					
;-------------------------------
				movlw   B'11100011'				; kvartc sisend, BUZ, Relee ja RS vljund.
    			movwf	TRISA					; 
				movlw   B'00001110'				; LCD vljundiks, nupud sisendiks 
    			movwf	TRISB					; 
;-------------------------------
				movlw	B'100010111'			; WPU-d OFF, prescaler 1:256 taimerile, TMR0 sisemise taktiga
				movwf	OPTION_REG				
				movlw	B'00000001'		 		; luba vaid T1 intsid 
				movwf	PIE1
				bcf		STATUS,RP0				; Pank 0		
;-------------------------------
				movlw	B'00001110'
    			movwf	PORTB					; LCD otcad madalax klaver krgeks
				movlw	B'11000011'
    			movwf	PORTA					; kik otcad madalax, kvartc ja sisendid krgex
				return
;===============================================================================
; ************ Tabelid *********************************************************
;===============================================================================
				org     h'0400'         
Mes_tabel:		movf	t1_count,W
				addwf	PCL;,F  						; vali sobiv mess vastavalt numbrile (vt. allpool)
mess_1:			dt      'A','t','w','o','o','d','i',' ','m','a','s','i','n','.',0xFF
	
GraphDef:		movf   	LCD_Count,W        
				addwf   PCL,F         
				retlw   b'00001110'  			; tht      (0)  
				retlw   b'00000000'         
				retlw   b'00001110'         
				retlw   b'00010001'         
				retlw   b'00010001'         
				retlw   b'00010001'         
				retlw   b'00001110'         
				retlw   0          
				retlw   b'00001110'  			; tht      (1)
				retlw   b'00000000'         
				retlw   b'00001110'         
				retlw   b'00000001'         
				retlw   b'00001111'         
				retlw   b'00010001'         
				retlw   b'00001111'         
				retlw   0                  
				retlw   b'00001010'  			; tht      (2)  
				retlw   b'00000000'         
				retlw   b'00001110'         
				retlw   b'00010001'         
				retlw   b'00010001'         
				retlw   b'00010001'         
				retlw   b'00001110'         
				retlw   0                  
				retlw   b'00001010'         	; tht 	 (3)
				retlw   b'00000000'         
				retlw   b'00010001'         
				retlw   b'00010001'         
				retlw   b'00010001'         
				retlw   b'00010001'         
				retlw   b'00001110'         
				retlw   0  
;===============================================================================
	end			
;===============================================================================
